TagLib::ID3v2::TableOfContentsFrame Class Reference

An implementation of ID3v2 table of contents frames. More...

`#include <tableofcontentsframe.h>`

Inheritance diagram for TagLib::ID3v2::TableOfContentsFrame:
[legend]
Collaboration diagram for TagLib::ID3v2::TableOfContentsFrame:
[legend]

## Public Member Functions

| TableOfContentsFrame (const ID3v2::Header *tagHeader, const ByteVector &data)
| TableOfContentsFrame (const ByteVector &elementID, const ByteVectorList &children=ByteVectorList(), const FrameList &embeddedFrames=FrameList())
| ~TableOfContentsFrame () override
| TableOfContentsFrame (const TableOfContentsFrame &)=delete
TableOfContentsFrame & | operator= (const TableOfContentsFrame &)=delete
ByteVector | elementID () const
bool | isTopLevel () const
bool | isOrdered () const
unsigned int | entryCount () const
ByteVectorList | childElements () const
void | setElementID (const ByteVector &eID)
void | setIsTopLevel (const bool &t)
void | setIsOrdered (const bool &o)
void | setChildElements (const ByteVectorList &l)
void | addChildElement (const ByteVector &cE)
void | removeChildElement (const ByteVector &cE)
const FrameListMap & | embeddedFrameListMap () const
const FrameList & | embeddedFrameList () const
const FrameList & | embeddedFrameList (const ByteVector &frameID) const
void | addEmbeddedFrame (Frame *frame)
void | removeEmbeddedFrame (Frame *frame, bool del=true)
void | removeEmbeddedFrames (const ByteVector &id)
String | toString () const override
PropertyMap | asProperties () const override
Public Member Functions inherited from TagLib::ID3v2::Frame
virtual | ~Frame ()
| Frame (const Frame &)=delete
Frame & | operator= (const Frame &)=delete
ByteVector | frameID () const
unsigned int | size () const
unsigned int | headerSize () const
void | setData (const ByteVector &data)
virtual void | setText (const String &text)
virtual StringList | toStringList () const
ByteVector | render () const
Header * | header () const

## Static Public Member Functions

static TableOfContentsFrame * | findByElementID (const Tag *tag, const ByteVector &eID)
static TableOfContentsFrame * | findTopLevel (const Tag *tag)
Static Public Member Functions inherited from TagLib::ID3v2::Frame
static ByteVector | textDelimiter (String::Type t)
static ByteVector | keyToFrameID (const String &)
static String | frameIDToKey (const ByteVector &)

## Protected Member Functions

void | parseFields (const ByteVector &data) override
ByteVector | renderFields () const override
Protected Member Functions inherited from TagLib::ID3v2::Frame
| Frame (const ByteVector &data)
| Frame (Header *h)
void | setHeader (Header *h, bool deleteCurrent=true)
void | parse (const ByteVector &data)
ByteVector | fieldData (const ByteVector &frameData) const
String | readStringField (const ByteVector &data, String::Type encoding, int *position=nullptr)
String::Type | checkTextEncoding (const StringList &fields, String::Type encoding) const

## Friends

class | FrameFactory

## Additional Inherited Members

Static Public Attributes inherited from TagLib::ID3v2::Frame
static const String | instrumentPrefix
static const String | commentPrefix
static const String | lyricsPrefix
static const String | urlPrefix
Static Protected Member Functions inherited from TagLib::ID3v2::Frame
static void | splitProperties (const PropertyMap &original, PropertyMap &singleFrameProperties, PropertyMap &tiplProperties, PropertyMap &tmclProperties)

## Detailed Description

An implementation of ID3v2 table of contents frames.

This is an implementation of ID3v2 table of contents frames. Purpose of this frame is to allow a table of contents to be defined.

## Constructor & Destructor Documentation

## TableOfContentsFrame() [1/3]

TagLib::ID3v2::TableOfContentsFrame::TableOfContentsFrame | ( | const ID3v2::Header * | tagHeader,
|  | const ByteVector & | data )

Creates a table of contents frame based on data. tagHeader is required as the internal frames are parsed based on the tag version.

Referenced by findByElementID(), findTopLevel(), operator=(), renderFields(), and TableOfContentsFrame().

## TableOfContentsFrame() [2/3]

TagLib::ID3v2::TableOfContentsFrame::TableOfContentsFrame | ( | const ByteVector & | elementID,
|  | const ByteVectorList & | children = ByteVectorList(),
|  | const FrameList & | embeddedFrames = FrameList() )

Creates a table of contents frame with the element ID elementID, the child elements children and embedded frames, which become owned by this frame, in embeddedFrames.

References elementID().

## ~TableOfContentsFrame()

TagLib::ID3v2::TableOfContentsFrame::~TableOfContentsFrame | ( |  | ) |

override

Destroys the frame.

## TableOfContentsFrame() [3/3]

TagLib::ID3v2::TableOfContentsFrame::TableOfContentsFrame | ( | const TableOfContentsFrame & |  | ) |

delete

References TableOfContentsFrame().

## Member Function Documentation

## addChildElement()

void TagLib::ID3v2::TableOfContentsFrame::addChildElement | ( | const ByteVector & | cE | ) |

Adds cE to the list of child elements of the frame.

See also
  childElements()

## addEmbeddedFrame()

void TagLib::ID3v2::TableOfContentsFrame::addEmbeddedFrame | ( | Frame * | frame | ) |

Add an embedded frame to the CTOC frame. At this point the CTOC frame takes ownership of the embedded frame and will handle freeing its memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

References TagLib::ID3v2::Frame::Frame().

## asProperties()

PropertyMap TagLib::ID3v2::TableOfContentsFrame::asProperties | ( |  | ) | const

override virtual

Parses the contents of this frame as PropertyMap. If that fails, the returned PropertyMap will be empty, and its unsupportedData() will contain this frame's ID.

Reimplemented from TagLib::ID3v2::Frame.

## childElements()

ByteVectorList TagLib::ID3v2::TableOfContentsFrame::childElements | ( |  | ) | const

Returns list of child elements of the frame.

See also
  setChildElements()

## elementID()

ByteVector TagLib::ID3v2::TableOfContentsFrame::elementID | ( |  | ) | const

Returns the elementID of the frame. Element ID is not intended to be human readable.

See also
  setElementID()

Referenced by TableOfContentsFrame().

## embeddedFrameList() [1/2]

const FrameList & TagLib::ID3v2::TableOfContentsFrame::embeddedFrameList | ( |  | ) | const

Returns a reference to the embedded frame list. This is a FrameList of all of the frames embedded in the CTOC frame in the order that they were parsed.

This can be useful if for example you want to iterate over the CTOC frame's embedded frames in the order that they occur in the CTOC frame.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

## embeddedFrameList() [2/2]

const FrameList & TagLib::ID3v2::TableOfContentsFrame::embeddedFrameList | ( | const ByteVector & | frameID | ) | const

Returns the embedded frame list for frames with the id frameID or an empty list if there are no embedded frames of that type. This is just a convenience and is equivalent to:

embeddedFrameListMap()[frameID];
TagLib::ID3v2::Frame::frameID
ByteVector frameID() const
TagLib::ID3v2::TableOfContentsFrame::embeddedFrameListMap
const FrameListMap & embeddedFrameListMap() const

See also
  embeddedFrameListMap()

References TagLib::ID3v2::Frame::frameID().

## embeddedFrameListMap()

const FrameListMap & TagLib::ID3v2::TableOfContentsFrame::embeddedFrameListMap | ( |  | ) | const

Returns a reference to the frame list map. This is a FrameListMap of all of the frames embedded in the CTOC frame.

This is the most convenient structure for accessing the CTOC frame's embedded frames. Many frame types allow multiple instances of the same frame type so this is a map of lists. In most cases however there will only be a single frame of a certain type.

Warning
  You should not modify this data structure directly, instead use addEmbeddedFrame() and removeEmbeddedFrame().

See also
  embeddedFrameList()

## entryCount()

unsigned int TagLib::ID3v2::TableOfContentsFrame::entryCount | ( |  | ) | const

Returns the count of child elements of the frame. It always corresponds to the size of the child elements list.

See also
  childElements()

## findByElementID()

TableOfContentsFrame * TagLib::ID3v2::TableOfContentsFrame::findByElementID | ( | const Tag * | tag,
|  | const ByteVector & | eID )

static

CTOC frames each have a unique element ID. This searches for a CTOC frame with the element ID eID and returns a pointer to it. This can be used to link together parent and child CTOC frames.

See also
  elementID()

References TableOfContentsFrame(), and TagLib::ID3v2::Frame::Tag.

## findTopLevel()

TableOfContentsFrame * TagLib::ID3v2::TableOfContentsFrame::findTopLevel | ( | const Tag * | tag | ) |

static

CTOC frames each contain a flag that indicates, if CTOC frame is top-level (there isn't any frame, which contains this frame in its child elements list). Only a single frame within the tag can be top-level. This searches for a top-level CTOC frame.

See also
  isTopLevel()

References TableOfContentsFrame(), and TagLib::ID3v2::Frame::Tag.

## isOrdered()

bool TagLib::ID3v2::TableOfContentsFrame::isOrdered | ( |  | ) | const

Returns `true`, if the child elements list entries are ordered.

See also
  setIsOrdered()

## isTopLevel()

bool TagLib::ID3v2::TableOfContentsFrame::isTopLevel | ( |  | ) | const

Returns `true`, if the frame is top-level (doesn't have any parent CTOC frame).

See also
  setIsTopLevel()

## operator=()

TableOfContentsFrame & TagLib::ID3v2::TableOfContentsFrame::operator= | ( | const TableOfContentsFrame & |  | ) |

delete

References TableOfContentsFrame().

## parseFields()

void TagLib::ID3v2::TableOfContentsFrame::parseFields | ( | const ByteVector & | data | ) |

override protected virtual

Called by parse() to parse the field data. It makes this information available through the public API. This must be overridden by the subclasses.

Implements TagLib::ID3v2::Frame.

## removeChildElement()

void TagLib::ID3v2::TableOfContentsFrame::removeChildElement | ( | const ByteVector & | cE | ) |

Removes cE to list of child elements of the frame.

See also
  childElements()

## removeEmbeddedFrame()

void TagLib::ID3v2::TableOfContentsFrame::removeEmbeddedFrame | ( | Frame * | frame,
|  | bool | del = true )

Remove an embedded frame from the CTOC frame. If del is `true` the frame's memory will be freed; if it is `false`, it must be deleted by the user.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

References TagLib::ID3v2::Frame::Frame().

## removeEmbeddedFrames()

void TagLib::ID3v2::TableOfContentsFrame::removeEmbeddedFrames | ( | const ByteVector & | id | ) |

Remove all embedded frames of type id from the CTOC frame and free their memory.

Note
  Using this method will invalidate any pointers on the list returned by embeddedFrameList()

## renderFields()

ByteVector TagLib::ID3v2::TableOfContentsFrame::renderFields | ( |  | ) | const

override protected virtual

Render the field data back to a binary format in a ByteVector. This must be overridden by subclasses.

Implements TagLib::ID3v2::Frame.

References TableOfContentsFrame(), and TAGLIB_MSVC_SUPPRESS_WARNING_NEEDS_TO_HAVE_DLL_INTERFACE.

## setChildElements()

void TagLib::ID3v2::TableOfContentsFrame::setChildElements | ( | const ByteVectorList & | l | ) |

Sets list of child elements of the frame to l.

See also
  childElements()

## setElementID()

void TagLib::ID3v2::TableOfContentsFrame::setElementID | ( | const ByteVector & | eID | ) |

Sets the elementID of the frame to eID.

See also
  elementID()

## setIsOrdered()

void TagLib::ID3v2::TableOfContentsFrame::setIsOrdered | ( | const bool & | o | ) |

Sets, if the child elements list entries are ordered.

See also
  isOrdered()

## setIsTopLevel()

void TagLib::ID3v2::TableOfContentsFrame::setIsTopLevel | ( | const bool & | t | ) |

Sets, if the frame is top-level (doesn't have any parent CTOC frame).

See also
  isTopLevel()

## toString()

String TagLib::ID3v2::TableOfContentsFrame::toString | ( |  | ) | const

override virtual

This returns the textual representation of the data in the frame. Subclasses must reimplement this method to provide a string representation of the frame's data.

Implements TagLib::ID3v2::Frame.

## Friends And Related Symbol Documentation

## FrameFactory

friend class FrameFactory

friend

References FrameFactory.

Referenced by FrameFactory.

The documentation for this class was generated from the following file:

- tableofcontentsframe.h